/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.CuponConvenioDAO;
import com.rjconsultores.ventaboletos.entidad.CuponConvenio;
import com.rjconsultores.ventaboletos.entidad.TipoConvenio;

/**
 *
 * @author Shiro
 */
@Repository("cuponConvenioDAO")
public class CuponConvenioHibernateDAO extends GenericHibernateDAO<CuponConvenio, Integer>
        implements CuponConvenioDAO {
    
    @Autowired
    public CuponConvenioHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<CuponConvenio> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

    public List<CuponConvenio> pesquisar(TipoConvenio tipoConvenio) {
       Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        if (tipoConvenio != null) {
            c.add(Restrictions.eq("tipoConvenio", tipoConvenio));
        }
        return c.list();
    }
}
